Index: pjproject/trunk/pjnath/build/Makefile
===================================================================
--- pjproject/trunk/pjnath/build/Makefile	(revision 4359)
+++ pjproject/trunk/pjnath/build/Makefile	(revision 4360)
@@ -41,5 +41,5 @@
 #
 export PJNATH_TEST_SRCDIR = ../src/pjnath-test
-export PJNATH_TEST_OBJS += ice_test.o stun.o sess_auth.o server.o \
+export PJNATH_TEST_OBJS += ice_test.o stun.o sess_auth.o server.o concur_test.o \
 			    stun_sock_test.o turn_sock_test.o test.o
 export PJNATH_TEST_CFLAGS += $(_CFLAGS)
Index: pjproject/trunk/pjnath/include/pjnath/ice_session.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/ice_session.h	(revision 4359)
+++ pjproject/trunk/pjnath/include/pjnath/ice_session.h	(revision 4360)
@@ -613,5 +613,5 @@
     pj_pool_t		*pool;			    /**< Pool instance.	    */
     void		*user_data;		    /**< App. data.	    */
-    pj_mutex_t		*mutex;			    /**< Mutex.		    */
+    pj_grp_lock_t	*grp_lock;		    /**< Group lock	    */
     pj_ice_sess_role	 role;			    /**< ICE role.	    */
     pj_ice_sess_options	 opt;			    /**< Options	    */
@@ -731,4 +731,6 @@
  *			generated.
  * @param local_passwd	Optional string to be used as local password.
+ * @param grp_lock	Optional group lock to be used by this session.
+ * 			If NULL, the session will create one itself.
  * @param p_ice		Pointer to receive the ICE session instance.
  *
@@ -742,4 +744,5 @@
 				        const pj_str_t *local_ufrag,
 				        const pj_str_t *local_passwd,
+				        pj_grp_lock_t *grp_lock,
 				        pj_ice_sess **p_ice);
 
Index: pjproject/trunk/pjnath/include/pjnath/stun_session.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/stun_session.h	(revision 4359)
+++ pjproject/trunk/pjnath/include/pjnath/stun_session.h	(revision 4360)
@@ -31,4 +31,5 @@
 #include <pjnath/stun_transaction.h>
 #include <pj/list.h>
+#include <pj/lock.h>
 #include <pj/timer.h>
 
@@ -385,4 +386,6 @@
  * @param cb		Session callback.
  * @param fingerprint	Enable message fingerprint for outgoing messages.
+ * @param grp_lock	Optional group lock to be used by this session.
+ * 			If NULL, the session will create one itself.
  * @param p_sess	Pointer to receive STUN session instance.
  *
@@ -393,4 +396,5 @@
 					    const pj_stun_session_cb *cb,
 					    pj_bool_t fingerprint,
+					    pj_grp_lock_t *grp_lock,
 					    pj_stun_session **p_sess);
 
@@ -430,20 +434,4 @@
  */
 PJ_DECL(void*) pj_stun_session_get_user_data(pj_stun_session *sess);
-
-/**
- * Change the lock object used by the STUN session. By default, the STUN
- * session uses a mutex to protect its internal data. If application already
- * protects access to STUN session with higher layer lock, it may disable
- * the mutex protection in the STUN session by changing the STUN session
- * lock to a NULL mutex.
- *
- * @param sess	    The STUN session instance.
- * @param lock	    New lock instance to be used by the STUN session.
- * @param auto_del  Specify whether STUN session should destroy this
- *		    lock instance when it's destroyed.
- */
-PJ_DECL(pj_status_t) pj_stun_session_set_lock(pj_stun_session *sess,
-					      pj_lock_t *lock,
-					      pj_bool_t auto_del);
 
 /**
Index: pjproject/trunk/pjnath/include/pjnath/stun_sock.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/stun_sock.h	(revision 4359)
+++ pjproject/trunk/pjnath/include/pjnath/stun_sock.h	(revision 4360)
@@ -28,4 +28,5 @@
 #include <pjlib-util/resolver.h>
 #include <pj/ioqueue.h>
+#include <pj/lock.h>
 #include <pj/sock.h>
 #include <pj/sock_qos.h>
@@ -218,4 +219,12 @@
 typedef struct pj_stun_sock_cfg
 {
+    /**
+     * The group lock to be used by the STUN socket. If NULL, the STUN socket
+     * will create one internally.
+     *
+     * Default: NULL
+     */
+    pj_grp_lock_t *grp_lock;
+
     /**
      * Packet buffer size.
Index: pjproject/trunk/pjnath/include/pjnath/stun_transaction.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/stun_transaction.h	(revision 4359)
+++ pjproject/trunk/pjnath/include/pjnath/stun_transaction.h	(revision 4360)
@@ -28,4 +28,5 @@
 #include <pjnath/stun_msg.h>
 #include <pjnath/stun_config.h>
+#include <pj/lock.h>
 
 
@@ -125,4 +126,5 @@
  *			various settings for the transaction.
  * @param pool		Pool to be used to allocate memory from.
+ * @param grp_lock	Group lock to synchronize.
  * @param cb		Callback structure, to be used by the transaction
  *			to send message and to notify the application about
@@ -134,4 +136,5 @@
 PJ_DECL(pj_status_t) pj_stun_client_tsx_create(	pj_stun_config *cfg,
 					        pj_pool_t *pool,
+					        pj_grp_lock_t *grp_lock,
 						const pj_stun_tsx_cb *cb,
 						pj_stun_client_tsx **p_tsx);
@@ -160,6 +163,5 @@
 
 /**
- * Destroy a STUN client transaction immediately. This function can be 
- * called at any time to stop the transaction and destroy it.
+ * Stop the client transaction.
  *
  * @param tsx		The STUN transaction.
@@ -168,5 +170,5 @@
  *			is NULL.
  */
-PJ_DECL(pj_status_t) pj_stun_client_tsx_destroy(pj_stun_client_tsx *tsx);
+PJ_DECL(pj_status_t) pj_stun_client_tsx_stop(pj_stun_client_tsx *tsx);
 
 
Index: pjproject/trunk/pjnath/include/pjnath/turn_session.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/turn_session.h	(revision 4359)
+++ pjproject/trunk/pjnath/include/pjnath/turn_session.h	(revision 4360)
@@ -418,5 +418,8 @@
  * @param af		Address family of the client connection. Currently
  *			pj_AF_INET() and pj_AF_INET6() are supported.
- * @param conn_type	Connection type to the TURN server. 
+ * @param conn_type	Connection type to the TURN server.
+ * @param grp_lock	Optional group lock object to be used by this session.
+ * 			If this value is NULL, the session will create
+ * 			a group lock internally.
  * @param cb		Callback to receive events from the TURN session.
  * @param options	Option flags, currently this value must be zero.
@@ -433,4 +436,5 @@
 					    int af,
 					    pj_turn_tp_type conn_type,
+					    pj_grp_lock_t *grp_lock,
 					    const pj_turn_session_cb *cb,
 					    unsigned options,
Index: pjproject/trunk/pjnath/include/pjnath/turn_sock.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/turn_sock.h	(revision 4359)
+++ pjproject/trunk/pjnath/include/pjnath/turn_sock.h	(revision 4360)
@@ -109,4 +109,12 @@
 typedef struct pj_turn_sock_cfg
 {
+    /**
+     * The group lock to be used by the STUN socket. If NULL, the STUN socket
+     * will create one internally.
+     *
+     * Default: NULL
+     */
+    pj_grp_lock_t *grp_lock;
+
     /**
      * Packet buffer size.
Index: pjproject/trunk/pjnath/src/pjnath-test/concur_test.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath-test/concur_test.c	(revision 4360)
+++ pjproject/trunk/pjnath/src/pjnath-test/concur_test.c	(revision 4360)
@@ -0,0 +1,360 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#include "test.h"
+
+#if INCLUDE_CONCUR_TEST
+
+#define THIS_FILE	"concur_test.c"
+
+/****************************************************************************/
+#define WORKER_THREAD_CNT	4
+#define SERVER_THREAD_CNT	4
+#define MAX_SOCK_CLIENTS	80
+
+struct stun_test_session
+{
+    pj_stun_config	 stun_cfg;
+
+    pj_lock_t		*lock;
+
+    pj_thread_t		*worker_threads[WORKER_THREAD_CNT];
+
+    pj_sock_t		 server_sock;
+    int			 server_port;
+    pj_thread_t		*server_threads[SERVER_THREAD_CNT];
+    pj_event_t		*server_event;
+
+    pj_bool_t		 thread_quit_flag;
+
+    /* Test parameters:  */
+    struct {
+	int		 client_got_response;
+
+	pj_bool_t	 server_wait_for_event;
+	pj_bool_t	 server_drop_request;
+	int		 client_sleep_after_start;
+	int		 client_sleep_before_destroy;
+    } param;
+};
+
+static int server_thread_proc(void *p)
+{
+    struct stun_test_session *test_sess = (struct stun_test_session*)p;
+    pj_pool_t *pool;
+    pj_status_t status;
+
+    PJ_LOG(4,(THIS_FILE, "Server thread running"));
+
+    pool = pj_pool_create(test_sess->stun_cfg.pf, "server", 512, 512, NULL);
+
+    while (!test_sess->thread_quit_flag) {
+	pj_time_val timeout = {0, 10};
+	pj_fd_set_t rdset;
+	int n;
+
+	/* Serve client */
+	PJ_FD_ZERO(&rdset);
+	PJ_FD_SET(test_sess->server_sock, &rdset);
+	n = pj_sock_select(test_sess->server_sock+1, &rdset,
+	                   NULL, NULL, &timeout);
+	if (n==1 && PJ_FD_ISSET(test_sess->server_sock, &rdset)) {
+	    pj_uint8_t pkt[512];
+	    pj_ssize_t pkt_len;
+	    pj_size_t res_len;
+	    pj_sockaddr client_addr;
+	    int addr_len;
+
+	    pj_stun_msg	*stun_req, *stun_res;
+
+	    pj_pool_reset(pool);
+
+	    /* Got query */
+	    pkt_len = sizeof(pkt);
+	    addr_len = sizeof(client_addr);
+	    status = pj_sock_recvfrom(test_sess->server_sock, pkt, &pkt_len,
+	                              0, &client_addr, &addr_len);
+	    if (status != PJ_SUCCESS) {
+		continue;
+	    }
+
+	    status = pj_stun_msg_decode(pool, pkt, pkt_len,
+	                                PJ_STUN_IS_DATAGRAM,
+	                                &stun_req, NULL, NULL);
+	    if (status != PJ_SUCCESS) {
+		PJ_PERROR(1,(THIS_FILE, status, "STUN request decode error"));
+		continue;
+	    }
+
+	    status = pj_stun_msg_create_response(pool, stun_req,
+	                                         PJ_STUN_SC_BAD_REQUEST, NULL,
+	                                         &stun_res);
+	    if (status != PJ_SUCCESS) {
+		PJ_PERROR(1,(THIS_FILE, status, "STUN create response error"));
+		continue;
+	    }
+
+	    status = pj_stun_msg_encode(stun_res, pkt, sizeof(pkt), 0,
+	                                NULL, &res_len);
+	    if (status != PJ_SUCCESS) {
+		PJ_PERROR(1,(THIS_FILE, status, "STUN encode error"));
+		continue;
+	    }
+
+	    /* Ignore request */
+	    if (test_sess->param.server_drop_request)
+		continue;
+
+	    /* Wait for signal to continue */
+	    if (test_sess->param.server_wait_for_event)
+		pj_event_wait(test_sess->server_event);
+
+	    pkt_len = res_len;
+	    pj_sock_sendto(test_sess->server_sock, pkt, &pkt_len, 0,
+	                   &client_addr, pj_sockaddr_get_len(&client_addr));
+	}
+    }
+
+    pj_pool_release(pool);
+
+    PJ_LOG(4,(THIS_FILE, "Server thread quitting"));
+    return 0;
+}
+
+static int worker_thread_proc(void *p)
+{
+    struct stun_test_session *test_sess = (struct stun_test_session*)p;
+
+    PJ_LOG(4,(THIS_FILE, "Worker thread running"));
+
+    while (!test_sess->thread_quit_flag) {
+	pj_time_val timeout = {0, 10};
+	pj_timer_heap_poll(test_sess->stun_cfg.timer_heap, NULL);
+	pj_ioqueue_poll(test_sess->stun_cfg.ioqueue, &timeout);
+    }
+
+    PJ_LOG(4,(THIS_FILE, "Worker thread quitting"));
+    return 0;
+}
+
+static pj_bool_t stun_sock_on_status(pj_stun_sock *stun_sock,
+                                     pj_stun_sock_op op,
+                                     pj_status_t status)
+{
+    struct stun_test_session *test_sess = (struct stun_test_session*)pj_stun_sock_get_user_data(stun_sock);
+    test_sess->param.client_got_response++;
+    return PJ_TRUE;
+}
+
+static int stun_destroy_test_session(struct stun_test_session *test_sess)
+{
+
+    unsigned i;
+    pj_stun_sock_cb stun_cb;
+    pj_status_t status;
+    pj_stun_sock *stun_sock[MAX_SOCK_CLIENTS];
+
+    pj_bzero(&stun_cb, sizeof(stun_cb));
+    stun_cb.on_status = &stun_sock_on_status;
+
+    pj_event_reset(test_sess->server_event);
+
+    /* Create all clients first */
+    for (i=0; i<MAX_SOCK_CLIENTS; ++i) {
+	char name[10];
+	sprintf(name, "stun%02d", i);
+	status = pj_stun_sock_create(&test_sess->stun_cfg, name, pj_AF_INET(),
+	                             &stun_cb, NULL, test_sess,
+	                             &stun_sock[i]);
+	if (status != PJ_SUCCESS) {
+	    PJ_PERROR(1,(THIS_FILE, status, "Error creating stun socket"));
+	    return -10;
+	}
+    }
+
+    /* Start resolution */
+    for (i=0; i<MAX_SOCK_CLIENTS; ++i) {
+	pj_str_t server_ip = pj_str("127.0.0.1");
+	status = pj_stun_sock_start(stun_sock[i], &server_ip,
+	                            test_sess->server_port, NULL);
+	if (status != PJ_SUCCESS) {
+	    PJ_PERROR(1,(THIS_FILE, status, "Error starting stun socket"));
+	    return -20;
+	}
+    }
+
+    /* settle down */
+    pj_thread_sleep(test_sess->param.client_sleep_after_start);
+
+    /* Resume server threads */
+    pj_event_set(test_sess->server_event);
+
+    pj_thread_sleep(test_sess->param.client_sleep_before_destroy);
+
+    /* Destroy clients */
+    for (i=0; i<MAX_SOCK_CLIENTS; ++i) {
+	status = pj_stun_sock_destroy(stun_sock[i]);
+	if (status != PJ_SUCCESS) {
+	    PJ_PERROR(1,(THIS_FILE, status, "Error destroying stun socket"));
+	}
+    }
+
+    return 0;
+}
+
+static int stun_destroy_test(void)
+{
+    enum { LOOP = 500 };
+    struct stun_test_session test_sess;
+    pj_sockaddr bind_addr;
+    int addr_len;
+    pj_caching_pool cp;
+    pj_pool_t *pool;
+    unsigned i;
+    pj_status_t status;
+    int rc = 0;
+
+    PJ_LOG(3,(THIS_FILE, "  STUN destroy concurrency test"));
+
+    pj_bzero(&test_sess, sizeof(test_sess));
+
+    pj_caching_pool_init(&cp, NULL, 0);
+    pool = pj_pool_create(&cp.factory, "testsess", 512, 512, NULL);
+
+    pj_stun_config_init(&test_sess.stun_cfg, &cp.factory, 0, NULL, NULL);
+
+    status = pj_timer_heap_create(pool, 1023, &test_sess.stun_cfg.timer_heap);
+    pj_assert(status == PJ_SUCCESS);
+
+    status = pj_lock_create_recursive_mutex(pool, NULL, &test_sess.lock);
+    pj_assert(status == PJ_SUCCESS);
+
+    pj_timer_heap_set_lock(test_sess.stun_cfg.timer_heap, test_sess.lock, PJ_TRUE);
+    pj_assert(status == PJ_SUCCESS);
+
+    status = pj_ioqueue_create(pool, 512, &test_sess.stun_cfg.ioqueue);
+    pj_assert(status == PJ_SUCCESS);
+
+    pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &test_sess.server_sock);
+    pj_sockaddr_init(pj_AF_INET(), &bind_addr, NULL, 0);
+    status = pj_sock_bind(test_sess.server_sock, &bind_addr, pj_sockaddr_get_len(&bind_addr));
+    pj_assert(status == PJ_SUCCESS);
+
+    addr_len = sizeof(bind_addr);
+    status = pj_sock_getsockname(test_sess.server_sock, &bind_addr, &addr_len);
+    pj_assert(status == PJ_SUCCESS);
+
+    test_sess.server_port = pj_sockaddr_get_port(&bind_addr);
+
+    status = pj_event_create(pool, NULL, PJ_TRUE, PJ_FALSE, &test_sess.server_event);
+    pj_assert(status == PJ_SUCCESS);
+
+    for (i=0; i<SERVER_THREAD_CNT; ++i) {
+	status = pj_thread_create(pool, NULL,
+	                          &server_thread_proc, &test_sess,
+	                          0, 0, &test_sess.server_threads[i]);
+	pj_assert(status == PJ_SUCCESS);
+    }
+
+    for (i=0; i<WORKER_THREAD_CNT; ++i) {
+	status = pj_thread_create(pool, NULL,
+	                          &worker_thread_proc, &test_sess,
+	                          0, 0, &test_sess.worker_threads[i]);
+	pj_assert(status == PJ_SUCCESS);
+    }
+
+    /* Test 1: Main thread calls destroy while callback is processing response */
+    PJ_LOG(3,(THIS_FILE, "    Destroy in main thread while callback is running"));
+    for (i=0; i<LOOP; ++i) {
+	int sleep = pj_rand() % 5;
+
+	PJ_LOG(3,(THIS_FILE, "      Try %-3d of %d", i+1, LOOP));
+
+	/* Test 1: destroy at the same time when receiving response */
+	pj_bzero(&test_sess.param, sizeof(test_sess.param));
+	test_sess.param.client_sleep_after_start = 20;
+	test_sess.param.client_sleep_before_destroy = sleep;
+	test_sess.param.server_wait_for_event = PJ_TRUE;
+	stun_destroy_test_session(&test_sess);
+	PJ_LOG(3,(THIS_FILE,
+		  "        stun test a: sleep delay:%d: clients with response: %d",
+		  sleep, test_sess.param.client_got_response));
+
+	/* Test 2: destroy at the same time with STUN retransmit timer */
+	test_sess.param.server_drop_request = PJ_TRUE;
+	test_sess.param.client_sleep_after_start = 0;
+	test_sess.param.client_sleep_before_destroy = PJ_STUN_RTO_VALUE;
+	test_sess.param.server_wait_for_event = PJ_FALSE;
+	stun_destroy_test_session(&test_sess);
+	PJ_LOG(3,(THIS_FILE, "        stun test b: retransmit concurrency"));
+
+	/* Test 3: destroy at the same time with receiving response
+	 * AND STUN retransmit timer */
+	test_sess.param.client_got_response = 0;
+	test_sess.param.server_drop_request = PJ_FALSE;
+	test_sess.param.client_sleep_after_start = PJ_STUN_RTO_VALUE;
+	test_sess.param.client_sleep_before_destroy = 0;
+	test_sess.param.server_wait_for_event = PJ_TRUE;
+	stun_destroy_test_session(&test_sess);
+	PJ_LOG(3,(THIS_FILE,
+		  "        stun test c: clients with response: %d",
+		  test_sess.param.client_got_response));
+
+	pj_thread_sleep(10);
+
+	ice_one_conc_test(&test_sess.stun_cfg, PJ_FALSE);
+
+	pj_thread_sleep(10);
+    }
+
+
+on_return:
+    test_sess.thread_quit_flag = PJ_TRUE;
+
+    for (i=0; i<SERVER_THREAD_CNT; ++i) {
+	pj_thread_join(test_sess.server_threads[i]);
+    }
+
+    for (i=0; i<WORKER_THREAD_CNT; ++i) {
+	pj_thread_join(test_sess.worker_threads[i]);
+    }
+
+    pj_event_destroy(test_sess.server_event);
+    pj_sock_close(test_sess.server_sock);
+    pj_ioqueue_destroy(test_sess.stun_cfg.ioqueue);
+    pj_timer_heap_destroy(test_sess.stun_cfg.timer_heap);
+
+    pj_pool_release(pool);
+    pj_caching_pool_destroy(&cp);
+
+    PJ_LOG(3,(THIS_FILE, "    Done. rc=%d", rc));
+    return rc;
+}
+
+
+int concur_test(void)
+{
+    int rc = 0;
+
+    rc += stun_destroy_test();
+
+    return 0;
+}
+
+#endif	/* INCLUDE_CONCUR_TEST */
Index: pjproject/trunk/pjnath/src/pjnath-test/ice_test.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath-test/ice_test.c	(revision 4359)
+++ pjproject/trunk/pjnath/src/pjnath-test/ice_test.c	(revision 4360)
@@ -30,5 +30,7 @@
 #define NODELAY		0xFFFFFFFF
 #define SRV_DOMAIN	"pjsip.lab.domain"
-
+#define MAX_THREADS	16
+
+#define THIS_FILE	"ice_test.c"
 #define INDENT		"    "
 
@@ -49,5 +51,5 @@
 };
 
-
+/*  Role    comp#   host?   stun?   turn?   flag?  ans_del snd_del des_del */
 /* Test session configuration */
 struct test_cfg
@@ -61,6 +63,6 @@
 
     unsigned    answer_delay;	/* Delay before sending SDP	*/
-    unsigned    send_delay;	/* Delay before sending data	*/
-    unsigned    destroy_delay;	/* Delay before destroy()	*/
+    unsigned	send_delay;	/* unused */
+    unsigned	destroy_delay;	/* unused */
 
     struct test_result expected;/* Expected result		*/
@@ -80,4 +82,15 @@
 };
 
+/* Session param */
+struct sess_param
+{
+    unsigned		 worker_cnt;
+    unsigned		 worker_timeout;
+    pj_bool_t		 worker_quit;
+
+    pj_bool_t		 destroy_after_create;
+    pj_bool_t		 destroy_after_one_done;
+};
+
 /* The test session */
 struct test_sess
@@ -87,5 +100,9 @@
     pj_dns_resolver	*resolver;
 
+    struct sess_param	*param;
+
     test_server		*server;
+
+    pj_thread_t		*worker_threads[MAX_THREADS];
 
     unsigned		 server_flag;
@@ -191,4 +208,5 @@
 		       struct test_cfg *caller_cfg,
 		       struct test_cfg *callee_cfg,
+		       struct sess_param *test_param,
 		       struct test_sess **p_sess)
 {
@@ -205,4 +223,5 @@
     sess->pool = pool;
     sess->stun_cfg = stun_cfg;
+    sess->param = test_param;
 
     pj_memcpy(&sess->caller.cfg, caller_cfg, sizeof(*caller_cfg));
@@ -262,4 +281,6 @@
 static void destroy_sess(struct test_sess *sess, unsigned wait_msec)
 {
+    unsigned i;
+
     if (sess->caller.ice) {
 	pj_ice_strans_destroy(sess->caller.ice);
@@ -270,4 +291,10 @@
 	pj_ice_strans_destroy(sess->callee.ice);
 	sess->callee.ice = NULL;
+    }
+
+    sess->param->worker_quit = PJ_TRUE;
+    for (i=0; i<sess->param->worker_cnt; ++i) {
+	if (sess->worker_threads[i])
+	    pj_thread_join(sess->worker_threads[i]);
     }
 
@@ -327,4 +354,7 @@
 	ept->result.nego_status = status;
 	break;
+    case PJ_ICE_STRANS_OP_KEEP_ALIVE:
+	/* keep alive failed? */
+	break;
     default:
 	pj_assert(!"Unknown op");
@@ -385,5 +415,5 @@
 	c1 = pj_ice_strans_get_valid_pair(ept1->ice, i+1);
 	if (c1 == NULL) {
-	    PJ_LOG(3,("", INDENT "err: unable to get valid pair for ice1 "
+	    PJ_LOG(3,(THIS_FILE, INDENT "err: unable to get valid pair for ice1 "
 			  "component %d", i+1));
 	    return start_err - 2;
@@ -392,5 +422,5 @@
 	c2 = pj_ice_strans_get_valid_pair(ept2->ice, i+1);
 	if (c2 == NULL) {
-	    PJ_LOG(3,("", INDENT "err: unable to get valid pair for ice2 "
+	    PJ_LOG(3,(THIS_FILE, INDENT "err: unable to get valid pair for ice2 "
 			  "component %d", i+1));
 	    return start_err - 4;
@@ -398,5 +428,5 @@
 
 	if (pj_sockaddr_cmp(&c1->rcand->addr, &c2->lcand->addr) != 0) {
-	    PJ_LOG(3,("", INDENT "err: candidate pair does not match "
+	    PJ_LOG(3,(THIS_FILE, INDENT "err: candidate pair does not match "
 			  "for component %d", i+1));
 	    return start_err - 6;
@@ -409,5 +439,5 @@
 	    pj_ice_strans_get_valid_pair(ept1->ice, i+1) != NULL) 
 	{
-	    PJ_LOG(3,("", INDENT "err: ice1 shouldn't have valid pair "
+	    PJ_LOG(3,(THIS_FILE, INDENT "err: ice1 shouldn't have valid pair "
 		          "for component %d", i+1));
 	    return start_err - 8;
@@ -416,5 +446,5 @@
 	    pj_ice_strans_get_valid_pair(ept2->ice, i+1) != NULL) 
 	{
-	    PJ_LOG(3,("", INDENT "err: ice2 shouldn't have valid pair "
+	    PJ_LOG(3,(THIS_FILE, INDENT "err: ice2 shouldn't have valid pair "
 		          "for component %d", i+1));
 	    return start_err - 9;
@@ -437,24 +467,41 @@
 					break; \
 				    } \
-				    if (t.sec - t0.sec > (timeout)) break; \
+				    PJ_TIME_VAL_SUB(t, t0); \
+				    if (PJ_TIME_VAL_MSEC(t) >= (timeout)) break; \
 				} \
 			    }
 
-
-static int perform_test(const char *title,
-			pj_stun_config *stun_cfg,
-			unsigned server_flag,
-		        struct test_cfg *caller_cfg,
-		        struct test_cfg *callee_cfg)
+int worker_thread_proc(void *data)
+{
+    pj_status_t rc;
+    struct test_sess *sess = (struct test_sess *) data;
+    pj_stun_config *stun_cfg = sess->stun_cfg;
+    
+    /* Wait until negotiation is complete on both endpoints */
+#define ALL_DONE    (sess->param->worker_quit || \
+			(sess->caller.result.nego_status!=PJ_EPENDING && \
+			 sess->callee.result.nego_status!=PJ_EPENDING))
+    WAIT_UNTIL(sess->param->worker_timeout, ALL_DONE, rc);
+    
+    return 0;
+}
+
+static int perform_test2(const char *title,
+			 pj_stun_config *stun_cfg,
+                         unsigned server_flag,
+		         struct test_cfg *caller_cfg,
+		         struct test_cfg *callee_cfg,
+		         struct sess_param *test_param)
 {
     pjlib_state pjlib_state;
     struct test_sess *sess;
+    unsigned i;
     int rc;
 
-    PJ_LOG(3,("", INDENT "%s", title));
+    PJ_LOG(3,(THIS_FILE, INDENT "%s", title));
 
     capture_pjlib_state(stun_cfg, &pjlib_state);
 
-    rc = create_sess(stun_cfg, server_flag, caller_cfg, callee_cfg, &sess);
+    rc = create_sess(stun_cfg, server_flag, caller_cfg, callee_cfg, test_param, &sess);
     if (rc != 0)
 	return rc;
@@ -464,8 +511,8 @@
 
     /* Wait until both ICE transports are initialized */
-    WAIT_UNTIL(30, ALL_READY, rc);
+    WAIT_UNTIL(30000, ALL_READY, rc);
 
     if (!ALL_READY) {
-	PJ_LOG(3,("", INDENT "err: init timed-out"));
+	PJ_LOG(3,(THIS_FILE, INDENT "err: init timed-out"));
 	destroy_sess(sess, 500);
 	return -100;
@@ -490,5 +537,4 @@
 	goto on_return;
     }
-
     /* Init ICE on caller */
     rc = pj_ice_strans_init_ice(sess->caller.ice, sess->caller.cfg.role, 
@@ -508,5 +554,4 @@
 	return -110;
     }
-
     /* Start ICE on callee */
     rc = start_ice(&sess->callee, &sess->caller);
@@ -515,8 +560,6 @@
 	return -120;
     }
-
     /* Wait for callee's answer_delay */
     poll_events(stun_cfg, sess->callee.cfg.answer_delay, PJ_FALSE);
-
     /* Start ICE on caller */
     rc = start_ice(&sess->caller, &sess->callee);
@@ -526,11 +569,35 @@
     }
 
-    /* Wait until negotiation is complete on both endpoints */
-#define ALL_DONE    (sess->caller.result.nego_status!=PJ_EPENDING && \
-		     sess->callee.result.nego_status!=PJ_EPENDING)
-    WAIT_UNTIL(30, ALL_DONE, rc);
-
+    for (i=0; i<sess->param->worker_cnt; ++i) {
+	pj_status_t status;
+
+	status = pj_thread_create(sess->pool, "worker_thread",
+				  worker_thread_proc, sess, 0, 0,
+				  &sess->worker_threads[i]);
+	if (status != PJ_SUCCESS) {
+	    PJ_LOG(3,(THIS_FILE, INDENT "err: create thread"));
+	    destroy_sess(sess, 500);
+	    return -135;
+	}
+    }
+
+    if (sess->param->destroy_after_create)
+	goto on_destroy;
+
+    if (sess->param->destroy_after_one_done) {
+	while (sess->caller.result.init_status==PJ_EPENDING &&
+	       sess->callee.result.init_status==PJ_EPENDING)
+	{
+	    if (sess->param->worker_cnt)
+		pj_thread_sleep(0);
+	    else
+		poll_events(stun_cfg, 0, PJ_FALSE);
+	}
+	goto on_destroy;
+    }
+    
+    WAIT_UNTIL(30000, ALL_DONE, rc);
     if (!ALL_DONE) {
-	PJ_LOG(3,("", INDENT "err: negotiation timed-out"));
+	PJ_LOG(3,(THIS_FILE, INDENT "err: negotiation timed-out"));
 	destroy_sess(sess, 500);
 	return -140;
@@ -562,4 +629,5 @@
 
     /* Looks like everything is okay */
+on_destroy:
 
     /* Destroy ICE stream transports first to let it de-allocate
@@ -579,5 +647,5 @@
 on_return:
     /* Wait.. */
-    poll_events(stun_cfg, 500, PJ_FALSE);
+    poll_events(stun_cfg, 200, PJ_FALSE);
 
     /* Now destroy everything */
@@ -592,5 +660,18 @@
     }
 
-    return 0;
+    return rc;
+}
+
+static int perform_test(const char *title,
+                        pj_stun_config *stun_cfg,
+                        unsigned server_flag,
+                        struct test_cfg *caller_cfg,
+                        struct test_cfg *callee_cfg)
+{
+    struct sess_param test_param;
+
+    pj_bzero(&test_param, sizeof(test_param));
+    return perform_test2(title, stun_cfg, server_flag, caller_cfg,
+                         callee_cfg, &test_param);
 }
 
@@ -681,5 +762,5 @@
 	    goto on_return;
     }
-
+    
     /* Simple test first with srflx candidate */
     if (1) {
@@ -745,5 +826,5 @@
 	};
 
-	rc = perform_test(cfg.title, &stun_cfg, cfg.server_flag, 
+	rc = perform_test(cfg.title, &stun_cfg, cfg.server_flag,
 			  &cfg.ua1, &cfg.ua2);
 	if (rc != 0)
@@ -786,4 +867,5 @@
     }
 
+
     /* STUN failure, testing TURN deallocation */
     if (1) {
@@ -793,9 +875,9 @@
 	    0xFFFF & (~(CREATE_STUN_SERVER)),
 	    /*  Role    comp#   host?   stun?   turn?   flag?  ans_del snd_del des_del */
-	    {ROLE1,	2,	 YES,    YES,	YES,	0,    0,	    0,	    0, {PJNATH_ESTUNTIMEDOUT, -1}},
-	    {ROLE2,	2,	 YES,    YES,	YES,	0,    0,	    0,	    0, {PJNATH_ESTUNTIMEDOUT, -1}}
+	    {ROLE1,	1,	 YES,    YES,	YES,	0,    0,	    0,	    0, {PJNATH_ESTUNTIMEDOUT, -1}},
+	    {ROLE2,	1,	 YES,    YES,	YES,	0,    0,	    0,	    0, {PJNATH_ESTUNTIMEDOUT, -1}}
 	};
 
-	rc = perform_test(cfg.title, &stun_cfg, cfg.server_flag, 
+	rc = perform_test(cfg.title, &stun_cfg, cfg.server_flag,
 			  &cfg.ua1, &cfg.ua2);
 	if (rc != 0)
@@ -819,5 +901,5 @@
 	unsigned d;
 
-	PJ_LOG(3,("", "  %s", cfg->title));
+	PJ_LOG(3,(THIS_FILE, "  %s", cfg->title));
 
 	/* For each test item, test with various answer delay */
@@ -877,2 +959,85 @@
 }
 
+int ice_one_conc_test(pj_stun_config *stun_cfg, int err_quit)
+{
+    struct sess_cfg_t {
+	const char	*title;
+	unsigned	 server_flag;
+	struct test_cfg	 ua1;
+	struct test_cfg	 ua2;
+    } cfg =
+    {
+	"Concurrency test",
+	0xFFFF,
+	/*  Role    comp#   host?   stun?   turn?   flag?  ans_del snd_del des_del */
+	{ROLE1,	1,	YES,     YES,	    YES,    0,	    0,	    0,	    0, {PJ_SUCCESS, PJ_SUCCESS}},
+	{ROLE2,	1,	YES,     YES,	    YES,    0,	    0,	    0,	    0, {PJ_SUCCESS, PJ_SUCCESS}}
+    };
+    struct sess_param test_param;
+    int rc;
+
+
+    /* test a: destroy as soon as nego starts */
+    cfg.title = "    ice test a: immediate destroy";
+    pj_bzero(&test_param, sizeof(test_param));
+    test_param.worker_cnt = 4;
+    test_param.worker_timeout = 1000;
+    test_param.destroy_after_create = PJ_TRUE;
+
+    rc = perform_test2(cfg.title, stun_cfg, cfg.server_flag,
+                       &cfg.ua1, &cfg.ua2, &test_param);
+    if (rc != 0 && err_quit)
+        return rc;
+
+    /* test b: destroy as soon as one is done */
+    cfg.title = "    ice test b: destroy after 1 success";
+    test_param.destroy_after_create = PJ_FALSE;
+    test_param.destroy_after_one_done = PJ_TRUE;
+
+    rc = perform_test2(cfg.title, stun_cfg, cfg.server_flag,
+                       &cfg.ua1, &cfg.ua2, &test_param);
+    if (rc != 0 && err_quit)
+        return rc;
+
+    /* test c: normal */
+    cfg.title = "    ice test c: normal flow";
+    pj_bzero(&test_param, sizeof(test_param));
+    test_param.worker_cnt = 4;
+    test_param.worker_timeout = 1000;
+
+    rc = perform_test2(cfg.title, stun_cfg, cfg.server_flag,
+                       &cfg.ua1, &cfg.ua2, &test_param);
+    if (rc != 0 && err_quit)
+        return rc;
+
+    return 0;
+}
+
+int ice_conc_test(void)
+{
+    const int LOOP = 100;
+    pj_pool_t *pool;
+    pj_stun_config stun_cfg;
+    unsigned i;
+    int rc;
+    
+    pool = pj_pool_create(mem, NULL, 512, 512, NULL);
+    rc = create_stun_config(pool, &stun_cfg);
+    if (rc != PJ_SUCCESS) {
+	pj_pool_release(pool);
+	return -7;
+    }
+    
+    for (i = 0; i < LOOP; i++) {
+	PJ_LOG(3,(THIS_FILE, INDENT "Test %d of %d", i+1, LOOP));
+	rc = ice_one_conc_test(&stun_cfg, PJ_TRUE);
+	if (rc)
+	    break;
+    }
+    
+on_return:
+    destroy_stun_config(&stun_cfg);
+    pj_pool_release(pool);
+
+    return rc;
+}
Index: pjproject/trunk/pjnath/src/pjnath-test/sess_auth.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath-test/sess_auth.c	(revision 4359)
+++ pjproject/trunk/pjnath/src/pjnath-test/sess_auth.c	(revision 4360)
@@ -248,5 +248,5 @@
     sess_cb.on_rx_request = &server_on_rx_request;
     sess_cb.on_send_msg = &server_send_msg;
-    status = pj_stun_session_create(&stun_cfg, "server", &sess_cb, PJ_FALSE, &server->sess);
+    status = pj_stun_session_create(&stun_cfg, "server", &sess_cb, PJ_FALSE, NULL, &server->sess);
     if (status != PJ_SUCCESS) {
 	destroy_server();
@@ -480,5 +480,5 @@
     sess_cb.on_request_complete = &client_on_request_complete;
     sess_cb.on_send_msg = &client_send_msg;
-    status = pj_stun_session_create(&stun_cfg, "client", &sess_cb, PJ_FALSE, &client->sess);
+    status = pj_stun_session_create(&stun_cfg, "client", &sess_cb, PJ_FALSE, NULL, &client->sess);
     if (status != PJ_SUCCESS) {
 	destroy_client_server();
